## segyio 1.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(segyio)

include(CheckFunctionExists)
include(CheckIncludeFile)
include(CTest)
include(GNUInstallDirs)

if (DEFINED ENV{SEGYIO_NO_GIT_VER})
    set(SEGYIO_NO_GIT_VER CACHE BOOL "Ignore version from git" ON)
endif ()

if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git AND NOT SEGYIO_NO_GIT_VER)
    find_program(git-bin git)
    execute_process(COMMAND ${git-bin} describe --tags
                    OUTPUT_VARIABLE git-describe
                    OUTPUT_STRIP_TRAILING_WHITESPACE
                    RESULT_VARIABLE describe-failure
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                    )
    if (NOT describe-failure)
        message(STATUS "Found version ${git-describe} from git")
    else ()
        message(STATUS "No version from git - falling back to 0.0.0")
        set(git-describe 0.0.0)
    endif ()

    string(REGEX REPLACE "^v" "" ver-describe "${git-describe}")
    unset(git-bin)
elseif (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/python/segyio/version.py)
    # tarball checkout - the version file should've been written when the
    # tarball was built
    file(READ python/segyio/version.py ver-describe)
    string(REGEX REPLACE "^version =" "" ver-describe ${ver-describe})
    string(REGEX REPLACE "'" "" ver-describe ${ver-describe})
    string(STRIP ${ver-describe} ver-describe)
    message(STATUS "Found version ${ver-describe} from segyio/version.py")
else ()
    set(ver-describe 0.0.0)
    message(STATUS "Could not find version, guessing ${ver-describe}")
endif ()

string(REPLACE . ";" version-list ${ver-describe})
list(GET version-list 0 segyio-major)
list(GET version-list 1 segyio-minor)
list(GET version-list 2 segyio-patch)
unset(version-list)

# versions can always be overriden with -Dsegyio_MAJOR=N
set(segyio_MAJOR ${segyio-major} CACHE STRING "Major version")
set(segyio_MINOR ${segyio-minor} CACHE STRING "Minor version")
set(segyio_PATCH ${segyio-patch} CACHE STRING "Patch")
set(segyio_VERSION ${segyio_MAJOR}.${segyio_MINOR}.${segyio_PATCH})
message(STATUS "segyio version ${segyio_VERSION}")

if (POLICY CMP0042)
    cmake_policy(SET CMP0042 NEW)
endif ()

option(BUILD_SHARED_LIBS "Build language bindings shared"           OFF)
option(BUILD_PYTHON      "Build Python library"                     ON)
option(REQUIRE_PYTHON    "Fail cmake if python cannot be built"     OFF)
option(BUILD_MEX         "Build Matlab mex files"                   OFF)
option(BUILD_DOC         "Build documentation"                      OFF)

check_include_file(netinet/in.h     HAVE_NETINET_IN_H)
check_include_file(arpa/inet.h      HAVE_ARPA_INET_H)
check_include_file(winsock2.h       HAVE_WINSOCK2_H)
check_include_file(getopt.h         HAVE_GETOPT_H)
check_include_file(sys/mman.h       HAVE_SYS_MMAN_H)
check_include_file(sys/stat.h       HAVE_SYS_STAT_H)
check_function_exists(getopt_long   HAVE_GETOPT_LONG)

if (HAVE_NETINET_IN_H)
    list(APPEND htons -DHAVE_NETINET_IN_H)
elseif (HAVE_ARPA_INET_H)
    list(APPEND htons -DHAVE_ARPA_INET_H)
elseif (HAVE_WINSOCK2_H)
    set(ws2 ws2_32)
    list(APPEND htons -DHAVE_WINSOCK2_H)
else()
    message(FATAL_ERROR "Could not find htons")
endif()

if (HAVE_SYS_MMAN_H)
    list(APPEND mmap -DHAVE_MMAP)
endif()

if (HAVE_SYS_STAT_H)
    list(APPEND fstat -DHAVE_SYS_STAT_H)

    check_function_exists(_fstati64 HAVE_FSTATI64)
    if (HAVE_FSTATI64)
        list(APPEND fstat -DHAVE_FSTATI64)
    endif ()

    check_function_exists(_ftelli64 HAVE_FTELLI64)
    if (HAVE_FTELLI64)
        list(APPEND fstat -DHAVE_FTELLI64)
    endif ()
else()
    message(FATAL_ERROR "Could not find sys/stat.h (fstat/ftelli)")
endif()

check_function_exists(ftello HAVE_FTELLO)
if (HAVE_FTELLO)
    list(APPEND ftello -DHAVE_FTELLO)
endif ()

if(NOT MSVC)
    set(m m)
endif()

if (NOT MSVC)
    # assuming gcc-style options
    set(c99 -std=c99)
    set(c++11 -std=c++11)
    # add warnings in debug mode
    list(APPEND warnings-c -Wall -Wextra -pedantic -Wformat-nonliteral
                           -Wcast-align -Wpointer-arith -Wmissing-declarations
                           -Wcast-qual -Wwrite-strings -Wchar-subscripts
                           -Wredundant-decls
    )
else()
    list(APPEND warnings-c /W3 /wd4996)
endif ()

# add documentation master target for other documentation sub targets to hook
# into
add_custom_target(doc ALL)

set(testdata ${CMAKE_CURRENT_SOURCE_DIR}/test-data)

add_subdirectory(external/catch2)
add_subdirectory(lib)
# language bindings
add_subdirectory(mex)
add_subdirectory(python)

add_subdirectory(applications)
add_subdirectory(man)

=== applications/CMakeLists.txt ===
project(segyio-apps)

if( NOT HAVE_GETOPT_H OR NOT HAVE_GETOPT_LONG )
    message(WARNING "Could not find getopt. Not building applications.")
    return ()
endif ()

add_library(apputils STATIC apputils.c)
target_link_libraries(apputils segyio)
target_compile_options(apputils BEFORE
    PRIVATE $<$<CONFIG:Debug>:${warnings-c}> ${c99}
)
target_compile_definitions(apputils PUBLIC
    -Dsegyio_MAJOR=${segyio_MAJOR}
    -Dsegyio_MINOR=${segyio_MINOR}
)

add_executable(segyinfo segyinfo.c)
target_link_libraries(segyinfo segyio)
target_compile_options(segyinfo BEFORE
    PRIVATE $<$<CONFIG:Debug>:${warnings-c}> ${c99}
)

add_executable(segyinspect segyinspect.c)
target_link_libraries(segyinspect segyio)
target_compile_options(segyinspect BEFORE
    PRIVATE $<$<CONFIG:Debug>:${warnings-c}> ${c99}
)

add_executable(segyio-cath segyio-cath.c)
target_link_libraries(segyio-cath segyio apputils)
target_compile_options(segyio-cath BEFORE
    PRIVATE $<$<CONFIG:Debug>:${warnings-c}> ${c99}
)

add_executable(segyio-catb segyio-catb.c)
target_link_libraries(segyio-catb segyio apputils)
target_compile_options(segyio-catb BEFORE
    PRIVATE $<$<CONFIG:Debug>:${warnings-c}> ${c99}
)

add_executable(segyio-catr segyio-catr.c)
target_link_libraries(segyio-catr segyio apputils)
target_compile_options(segyio-catr BEFORE
    PRIVATE $<$<CONFIG:Debug>:${warnings-c}> ${c99}
)

add_executable(segyio-crop segyio-crop.c)
target_link_libraries(segyio-crop segyio apputils)
target_compile_options(segyio-crop BEFORE
    PRIVATE $<$<CONFIG:Debug>:${warnings-c}> ${c99}
)

install(TARGETS segyio-cath
                segyio-catb
                segyio-catr
                segyio-crop
        DESTINATION ${CMAKE_INSTALL_BINDIR})

if (NOT BUILD_TESTING)
    return ()
endif ()

set(small ${testdata}/small.sgy)
set(test ${CMAKE_CURRENT_SOURCE_DIR}/test)
add_test(NAME catr.arg.t        COMMAND segyio-catr -t 5 ${small})
add_test(NAME catr.arg.r1       COMMAND segyio-catr -r 5 ${small})
add_test(NAME catr.arg.r2       COMMAND segyio-catr -r 1 2 ${small})
add_test(NAME catr.arg.r3       COMMAND segyio-catr -r 1 2 3 ${small} -r 5 6)
add_test(NAME catr.arg.multiple COMMAND segyio-catr "-r 1" 5 2 ${small} -r 1 6)
add_test(NAME catr.arg.rt       COMMAND segyio-catr -r 1 2 ${small} -t 5)
add_test(NAME catr.arg.fmt      COMMAND segyio-catr -f ieee ${small})

add_test(NAME catb.arg.help     COMMAND segyio-catb --help)
add_test(NAME catb.fail.nosegy  COMMAND segyio-catb ${test}/catb.output)
add_test(NAME catb.fail.nofile  COMMAND segyio-catb not-exist)
add_test(NAME catb.fail.noarg   COMMAND segyio-catb)

add_test(NAME cath.arg.help     COMMAND segyio-cath --help)
add_test(NAME cath.fail.nosegy  COMMAND segyio-cath ${test}/cath.output)
add_test(NAME cath.fail.nofile  COMMAND segyio-cath --strict not-exist)
add_test(NAME cath.fail.noarg   COMMAND segyio-cath)

set_tests_properties(catb.fail.nosegy
                     catb.fail.nofile
                     catb.fail.noarg
                     cath.fail.nosegy
                     cath.fail.nofile
                     cath.fail.noarg
    PROPERTIES WILL_FAIL ON)

add_custom_target(test-app-output
    ALL
    DEPENDS catb.out
            cath.out
            catr.out
            crop-ns.out
            crop-ns.sgy
)
add_custom_command(
    OUTPUT catb.out cath.out catr.out
    COMMENT "running applications for output comparison"
    DEPENDS segyio-catb segyio-cath segyio-catr
            test/catb.output
            test/cath.output
            test/catr.output
    COMMAND segyio-catb ${small} > catb.out
    COMMAND segyio-cath ${small} > cath.out
    COMMAND segyio-catr -r 4 9 -t 12 ${small} > catr.out
)
add_custom_command(
    OUTPUT crop-ns.out crop-ns.sgy
    COMMENT "running applications for crop testing"
    DEPENDS segyio-crop segyio-catr
            test/crop-ns.output
    COMMAND segyio-crop -S 25 ${small} crop-ns.sgy
    COMMAND segyio-catr crop-ns.sgy > crop-ns.out
)

add_test(NAME catb.output
         COMMAND ${CMAKE_COMMAND} -E compare_files ${test}/catb.output catb.out
)
add_test(NAME cath.output
         COMMAND ${CMAKE_COMMAND} -E compare_files ${test}/cath.output cath.out
)
add_test(NAME catr.output
         COMMAND ${CMAKE_COMMAND} -E compare_files ${test}/catr.output catr.out
)

add_test(NAME crop.samplecount
         COMMAND ${CMAKE_COMMAND} -E compare_files ${test}/crop-ns.output
                                                   crop-ns.out
)

=== lib/CMakeLists.txt ===
project(libsegyio C)

set(SOURCE_FILES src/segy.c)

set(STATIC_NAME segyio)
if(MSVC)
    # MSVC outputs the same name for static and shared libraries (with the same
    # extension), so we need to differentiate between the two somehow.
    set(STATIC_NAME "${STATIC_NAME}-static")
    set(DLL_EXPORT_FILES src/segy.def)
endif()

#
# static build
#
add_library(segyio-static STATIC ${SOURCE_FILES})
target_link_libraries(segyio-static ${m} ${ws2})
target_compile_definitions(segyio-static PRIVATE
    ${htons} ${mmap} ${fstat} ${ftello})
target_compile_options(segyio-static BEFORE
    PRIVATE $<$<CONFIG:Debug>:${warnings-c}> ${c99}
)
set_target_properties(segyio-static PROPERTIES
                      OUTPUT_NAME ${STATIC_NAME}
                      CLEAN_DIRECT_OUTPUT 1)
target_include_directories(
    segyio-static PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    PRIVATE src include)

#
# dynamic build
#
add_library(segyio-shared SHARED ${SOURCE_FILES} ${DLL_EXPORT_FILES})
target_link_libraries(segyio-shared ${m} ${ws2})
target_compile_options(segyio-shared BEFORE
    PRIVATE $<$<CONFIG:Debug>:${warnings-c}> ${c99}
)
target_compile_definitions(segyio-shared PRIVATE
    ${htons} ${mmap} ${fstat} ${ftello})
set_target_properties(segyio-shared PROPERTIES
                      SOVERSION   ${segyio_MAJOR}
                      VERSION     ${segyio_MAJOR}
                      OUTPUT_NAME segyio
                      CLEAN_DIRECT_OUTPUT 1)
target_include_directories(
    segyio-shared PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    PRIVATE src include)

if (BUILD_SHARED_LIBS)
    add_library(segyio ALIAS segyio-shared)
else ()
    add_library(segyio ALIAS segyio-static)
    set_property(TARGET segyio-static PROPERTY POSITION_INDEPENDENT_CODE ON)
endif ()

#
# install & export
#
install(TARGETS segyio-static segyio-shared
        EXPORT segyio
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY include/ DESTINATION include)
install(EXPORT segyio DESTINATION share/segyio/cmake FILE segyio-config.cmake)
export(TARGETS segyio-static segyio-shared FILE segyio-config.cmake)

if (NOT BUILD_TESTING)
    return ()
endif ()

configure_file(${testdata}/small.sgy test-data/small.sgy             COPYONLY)
configure_file(${testdata}/f3.sgy    test-data/f3.sgy                COPYONLY)
configure_file(${testdata}/text.sgy  test-data/text.sgy              COPYONLY)

add_executable(c.segy test/testsuite.cpp
                      test/segy.cpp
                      test/mmap.cpp)
target_include_directories(c.segy PRIVATE src)
target_link_libraries(c.segy catch2 segyio)
target_compile_options(c.segy BEFORE PRIVATE
                       ${c++11} $<$<CONFIG:Debug>:${warnings-c}> ${mmap})
add_test(NAME c.segy COMMAND c.segy ~[mmap] [c.segy])
add_test(NAME c.segy.mmap COMMAND c.segy [mmap])

=== python/CMakeLists.txt ===
project(segyio-python)

if (REQUIRE_PYTHON)
    set(BUILD_PYTHON ON)
endif()

if (NOT BUILD_PYTHON)
    return()
endif()

find_package(PythonInterp REQUIRED)

if (NOT PYTHON_EXECUTABLE AND REQUIRE_PYTHON)
    message(SEND_ERROR "Could not find python executable")
    return()
endif()

if (NOT PYTHON_EXECUTABLE)
    message(WARNING "Could not find python - skipping python bindings")
    return()
endif()

if (PYTHON_INSTALL_LAYOUT)
    set(setup-install-layout --install-layout ${PYTHON_INSTALL_LAYOUT})
endif()

set(python ${PYTHON_EXECUTABLE})

if (NOT WIN32)
    # setuptools on microsoft compilers doesn't support the --library-dir or
    # --build-dir flag and crashes, so only pass it on non-microsoft platforms
    set(setup-py-libdir build_ext
                            --rpath        $<TARGET_FILE_DIR:segyio-shared>
                            --library-dirs $<TARGET_FILE_DIR:segyio-shared>)

    set(install-no-rpath install_lib --build-dir build/install)
    set(build-no-rpath --library-dirs $<TARGET_FILE_DIR:segyio-shared>
                       build --build-lib build/install)
else ()
    set(copy-dll-to-src ${CMAKE_COMMAND} -E
        copy $<TARGET_FILE:segyio-shared>
        ${CMAKE_CURRENT_SOURCE_DIR}/segyio/$<TARGET_FILE_NAME:segyio-shared>)
endif ()


set(setup-py ${CMAKE_SOURCE_DIR}/setup.py)
add_custom_target(
    segyio-python ALL
    COMMENT "Building python library with setup.py"
    SOURCES ${setup-py}
    DEPENDS ${setup-py}
    VERBATIM

    # copy the examples to have them runnable from a relative directory, so
    # that a locally-installed segyio can be imported
    COMMAND ${CMAKE_COMMAND} -E
        copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/examples .

    # do the same to tests. running through setup.py test is *very* slow, so
    # invoke unittest manually from the build directory. more importantly,
    # setup.py test will pollute the source directory with egg info and
    # extensions, which is unacceptable in a cmake world
    COMMAND ${CMAKE_COMMAND} -E
        copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/test test

    # setuptools on windows breaks spectacularly when the library isn't
    # available in the same directory, and build_ext --library-dirs is not
    # support on msvc is not supported, so we must copy out the libsegyio core
    # object and put it here
    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:segyio-shared>
                                     $<TARGET_FILE_NAME:segyio-shared>

    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_LINKER_FILE:segyio-shared>
                                     $<TARGET_LINKER_FILE_NAME:segyio-shared>

    # on windows, copy the freshly-built dll to the source directory. this
    # voilates the cmake spirit (as does the version.py writing from
    # setuptools-scm), but there's no auditwheel like tool to help fix the
    # wheel, and the dll must still be bundled in order to make the package
    # work. it's paired with package_data in setup.py. this is necessary
    # because setup.py assumes all files to bundled with the package are
    # relative downwards and in the package itself, with poor support for
    # grabbing other files and adding to it later.
    COMMAND ${copy-dll-to-src}

    # install the lib in the build-dir so that the examples can load that from
    # current working dir
    COMMAND ${python} ${setup-py} ${setup-py-libdir} install_lib -d .

    # to maintain good make && make install behaviour, the extension is built
    # twice, one with rpath (for testing and build-dir-local) and one for
    # installation
    COMMAND ${python} ${setup-py} build_ext ${build-no-rpath}
)

add_dependencies(segyio-python segyio-shared)

# write egg_info to the build dir in order not to pollute the source directory
# and install as if it was through some other distro by using single-version,
# so that install won't die on possibly missing pythonpath
# setup.py install doesn't respect DESTDIR, so "force" it by changing the
# --root if DESTDIR is passed
install(CODE "
if (DEFINED ENV{DESTDIR})
    get_filename_component(abs-destdir \"\$ENV{DESTDIR}\" ABSOLUTE)
    set(root_destdir --root=\${abs-destdir})
endif()

execute_process(COMMAND
${python} ${setup-py}
    install_egg_info --install-dir .
    egg_info --egg-base .
    ${install-no-rpath}
    install --prefix=${CMAKE_INSTALL_PREFIX}
            --single-version-externally-managed
            --record installed-files
            ${setup-install-layout}
            \${root_destdir}
WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)")

option(BUILD_PYDOC "Build python documentation" OFF)

if(BUILD_DOC)
    set(BUILD_PYDOC ON)
endif()

if(BUILD_PYDOC)
    find_program(sphinx sphinx-build)

    if(NOT sphinx)
        message(WARNING "Could not find sphinx, skipping python documentation")
        set(BUILD_PYDOC OFF)
    endif()

endif()

if(BUILD_PYDOC AND sphinx)
    # use the -d argument to avoid putting cache dir in docs/, because that
    # directory will be install'd
    add_custom_target(pydoc
        COMMAND ${sphinx}
            -d ${CMAKE_CURRENT_BINARY_DIR}/.doctrees
            ${SPHINX_ARGS}
            ${CMAKE_CURRENT_SOURCE_DIR}/docs
            ${CMAKE_CURRENT_BINARY_DIR}/docs
        DEPENDS docs/conf.py
                docs/index.rst
                docs/segyio.rst
        COMMENT "Building python documentation with sphinx"
    )
    add_dependencies(doc pydoc)

    install(
        DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/docs/
        DESTINATION ${CMAKE_INSTALL_DATADIR}/doc/segyio
    )
endif()

if(NOT BUILD_TESTING)
    return()
endif()

file(GLOB sgys "${testdata}/*.sgy")
foreach (sgy ${sgys})
    get_filename_component(fl ${sgy} NAME)
    configure_file(${sgy} test-data/${fl} COPYONLY)
endforeach ()

set(pytest ${python} -m pytest)
add_test(NAME python.unit COMMAND ${pytest} test/)

configure_file(${testdata}/small.sgy
               test-data/write.sgy
               COPYONLY)

add_test(NAME python.example.about        COMMAND ${python} about.py test-data/small.sgy INLINE_3D CROSSLINE_3D)
add_test(NAME python.example.write        COMMAND ${python} write.py test-data/write.sgy)
add_test(NAME python.example.makefile     COMMAND ${python} make-file.py test-data/large-file.sgy 20 1 20 1 20)
add_test(NAME python.example.makepsfile   COMMAND ${python} make-ps-file.py test-data/small-prestack.sgy 10 1 5 1 4 1 3)
add_test(NAME python.example.subcube      COMMAND ${python} copy-sub-cube.py test-data/small.sgy test-data/copy.sgy)
add_test(NAME python.example.rotate       COMMAND ${python} make-rotated-copies.py test-data/small.sgy ex-rotate.sgy)
add_test(NAME python.example.scan_min_max COMMAND ${python} scan_min_max.py test-data/small.sgy)

=== debian/changelog ===
segyio (1.6.0-1build1) cosmic; urgency=medium

  * No-change rebuild to build for python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 28 Jun 2018 12:37:29 +0000

segyio (1.6.0-1) unstable; urgency=medium

  * New upstream release
  * Add two new symbols to d/libsegyio1.symbols
  * Remove X-Python-3-version field in d/control

 -- Jørgen Kvalsvik <jokva@statoil.com>  Thu, 07 Jun 2018 15:31:57 +0200

=== debian/control ===
Source: segyio
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jørgen Kvalsvik <jokva@statoil.com>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               dh-python,
               python3 (>= 3.4),
               python3-all-dev,
               python3-numpy,
               python3-pytest,
               python3-pytest-runner,
               python3-setuptools,
               python3-setuptools-scm
Standards-Version: 4.1.4
Vcs-git: https://salsa.debian.org/science-team/segyio.git
Vcs-browser: https://salsa.debian.org/science-team/segyio
Homepage: https://github.com/statoil/segyio
Testsuite: autopkgtest-pkg-python

Package: libsegyio1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: SEG-Y read/write library for seismic processing (runtime)
 segyio is a fast and practical library for reading and writing seismic data in
 SEG-Y format. segyio is random access oriented for modern computers with
 simple read/write primitives on lines.

Package: libsegyio-dev
Architecture: any
Section: libdevel
Depends: libsegyio1 (= ${binary:Version}),
         ${misc:Depends}
Description: SEG-Y read/write library for seismic processing (development)
 segyio is a fast and practical library for reading and writing seismic data in
 SEG-Y format. segyio is random access oriented for modern computers with
 simple read/write primitives on lines.
 .
 This package includes the header files and the static library.

Package: segyio-bin
Architecture: any
Depends: libsegyio1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: SEG-Y read/write library for seismic processing (shell utilities)
 segyio is a fast and practical library for reading and writing seismic data in
 SEG-Y format. segyio is random access oriented for modern computers with
 simple read/write primitives on lines.
 .
 This package contains useful shell programs.

Package: python3-segyio
Architecture: any
Section: python
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends}
Description: SEG-Y read/write library for seismic processing (python3 bindings)
 segyio is a fast and practical library for reading and writing seismic data in
 SEG-Y format. segyio is random access oriented for modern computers simple
 read/write primitives on lines.
 .
 This package contain the python3 interface.

=== debian/rules ===
#!/usr/bin/make -f

DEB_MAINT_BUILD_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export PYBUILD_SYSTEM=cmake
export SEGYIO_NO_GIT_VER=1

%:
	dh $@ --buildsystem=pybuild --with python3

override_dh_auto_configure:
	dh_auto_configure -- --configure-args="-DBUILD_SHARED_LIBS=ON -DPYTHON_INSTALL_LAYOUT=deb"

override_dh_python3:
	dh_python3 --requires=requirements.txt

override_dh_missing:
	dh_missing --list-missing

## segyio 1.7.1

=== applications/CMakeLists.txt ===
--- 
+++ 
@@ -63,7 +63,8 @@
 
 set(small ${testdata}/small.sgy)
 set(test ${CMAKE_CURRENT_SOURCE_DIR}/test)
-add_test(NAME catr.arg.t        COMMAND segyio-catr -t 5 ${small})
+add_test(NAME catr.arg.t1       COMMAND segyio-catr -t 0 ${small})
+add_test(NAME catr.arg.t2       COMMAND segyio-catr -t 5 ${small})
 add_test(NAME catr.arg.r1       COMMAND segyio-catr -r 5 ${small})
 add_test(NAME catr.arg.r2       COMMAND segyio-catr -r 1 2 ${small})
 add_test(NAME catr.arg.r3       COMMAND segyio-catr -r 1 2 3 ${small} -r 5 6)
@@ -81,7 +82,8 @@
 add_test(NAME cath.fail.nofile  COMMAND segyio-cath --strict not-exist)
 add_test(NAME cath.fail.noarg   COMMAND segyio-cath)
 
-set_tests_properties(catb.fail.nosegy
+set_tests_properties(catr.arg.t1
+                     catb.fail.nosegy
                      catb.fail.nofile
                      catb.fail.noarg
                      cath.fail.nosegy
@@ -105,8 +107,10 @@
             test/cath.output
             test/catr.output
     COMMAND segyio-catb ${small} > catb.out
+    COMMAND segyio-catb ${small} -n -d > catbnd.out
     COMMAND segyio-cath ${small} > cath.out
     COMMAND segyio-catr -r 4 9 -t 12 ${small} > catr.out
+    COMMAND segyio-catr -t 1 ${small} -n -d > catrnd.out
 )
 add_custom_command(
     OUTPUT crop-ns.out crop-ns.sgy
@@ -120,13 +124,20 @@
 add_test(NAME catb.output
          COMMAND ${CMAKE_COMMAND} -E compare_files ${test}/catb.output catb.out
 )
+add_test(NAME catb.output.nd
+         COMMAND ${CMAKE_COMMAND} -E compare_files ${test}/catbnd.output
+                                                   catbnd.out
+)
 add_test(NAME cath.output
          COMMAND ${CMAKE_COMMAND} -E compare_files ${test}/cath.output cath.out
 )
 add_test(NAME catr.output
          COMMAND ${CMAKE_COMMAND} -E compare_files ${test}/catr.output catr.out
 )
-
+add_test(NAME catr.output.nd
+         COMMAND ${CMAKE_COMMAND} -E compare_files ${test}/catrnd.output
+                                                   catrnd.out
+)
 add_test(NAME crop.samplecount
          COMMAND ${CMAKE_COMMAND} -E compare_files ${test}/crop-ns.output
                                                    crop-ns.out

=== lib/CMakeLists.txt ===
project(libsegyio C)

if(MSVC)
    set(DLL_EXPORT_FILES src/segy.def)
endif()

add_library(segyio src/segy.c ${DLL_EXPORT_FILES})
target_link_libraries(segyio ${m} ${ws2})
target_compile_options(segyio BEFORE
    PRIVATE
        ${c99}
        $<$<CONFIG:Debug>:${warnings-c}>
)
target_compile_definitions(segyio
    PRIVATE
        ${htons}
        ${mmap}
        ${fstat}
        ${ftello}
)
set_target_properties(segyio
                      PROPERTIES
                      SOVERSION   ${segyio_MAJOR}
                      VERSION     ${segyio_MAJOR}
)
target_include_directories(segyio
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
    PRIVATE
        src
        include
)

#
# install & export
#
install(TARGETS segyio
        EXPORT segyio
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)
install(DIRECTORY include/ DESTINATION include)
install(EXPORT segyio
        DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/segyio/cmake
        FILE segyio-config.cmake
)
export(TARGETS segyio FILE segyio-config.cmake)

if (NOT BUILD_TESTING)
    return ()
endif ()

configure_file(${testdata}/small.sgy test-data/small.sgy             COPYONLY)
configure_file(${testdata}/1x1.sgy   test-data/1x1.sgy               COPYONLY)
configure_file(${testdata}/1xN.sgy   test-data/1xN.sgy               COPYONLY)
configure_file(${testdata}/f3.sgy    test-data/f3.sgy                COPYONLY)
configure_file(${testdata}/text.sgy  test-data/text.sgy              COPYONLY)

add_executable(c.segy test/testsuite.cpp
                      test/segy.cpp
                      test/mmap.cpp
)
target_include_directories(c.segy PRIVATE src)
target_link_libraries(c.segy catch2 segyio)
target_compile_options(c.segy BEFORE PRIVATE
    ${c++11}
    ${mmap}
    $<$<CONFIG:Debug>:${warnings-c}>
)
add_test(NAME c.segy COMMAND c.segy ~[mmap] [c.segy])
add_test(NAME c.segy.mmap COMMAND c.segy [mmap])

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -30,16 +30,16 @@
     # setuptools on microsoft compilers doesn't support the --library-dir or
     # --build-dir flag and crashes, so only pass it on non-microsoft platforms
     set(setup-py-libdir build_ext
-                            --rpath        $<TARGET_FILE_DIR:segyio-shared>
-                            --library-dirs $<TARGET_FILE_DIR:segyio-shared>)
+                            --rpath        $<TARGET_FILE_DIR:segyio>
+                            --library-dirs $<TARGET_FILE_DIR:segyio>)
 
     set(install-no-rpath install_lib --build-dir build/install)
-    set(build-no-rpath --library-dirs $<TARGET_FILE_DIR:segyio-shared>
+    set(build-no-rpath --library-dirs $<TARGET_FILE_DIR:segyio>
                        build --build-lib build/install)
 else ()
     set(copy-dll-to-src ${CMAKE_COMMAND} -E
-        copy $<TARGET_FILE:segyio-shared>
-        ${CMAKE_CURRENT_SOURCE_DIR}/segyio/$<TARGET_FILE_NAME:segyio-shared>)
+        copy $<TARGET_FILE:segyio>
+        ${CMAKE_CURRENT_SOURCE_DIR}/segyio/$<TARGET_FILE_NAME:segyio>)
 endif ()
 
 
@@ -67,11 +67,11 @@
     # available in the same directory, and build_ext --library-dirs is not
     # support on msvc is not supported, so we must copy out the libsegyio core
     # object and put it here
-    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:segyio-shared>
-                                     $<TARGET_FILE_NAME:segyio-shared>
+    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:segyio>
+                                     $<TARGET_FILE_NAME:segyio>
 
-    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_LINKER_FILE:segyio-shared>
-                                     $<TARGET_LINKER_FILE_NAME:segyio-shared>
+    COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_LINKER_FILE:segyio>
+                                     $<TARGET_LINKER_FILE_NAME:segyio>
 
     # on windows, copy the freshly-built dll to the source directory. this
     # voilates the cmake spirit (as does the version.py writing from
@@ -93,7 +93,7 @@
     COMMAND ${python} ${setup-py} build_ext ${build-no-rpath}
 )
 
-add_dependencies(segyio-python segyio-shared)
+add_dependencies(segyio-python segyio)
 
 # write egg_info to the build dir in order not to pollute the source directory
 # and install as if it was through some other distro by using single-version,
@@ -181,3 +181,4 @@
 add_test(NAME python.example.subcube      COMMAND ${python} copy-sub-cube.py test-data/small.sgy test-data/copy.sgy)
 add_test(NAME python.example.rotate       COMMAND ${python} make-rotated-copies.py test-data/small.sgy ex-rotate.sgy)
 add_test(NAME python.example.scan_min_max COMMAND ${python} scan_min_max.py test-data/small.sgy)
+add_test(NAME python.example.multi-text   COMMAND ${python} make-multiple-text.py test-data/multi-text.sgy)

=== debian/changelog ===
segyio (1.7.1-2) unstable; urgency=medium

  * New packaging release
  * Updated d/rules to use only one dh invocation
  * Add d/clean to remove python .egg-info files
  * Add Build-Depends-Package field to libsegyio1.symbols

 -- Jørgen Kvalsvik <jokva@equinor.com>  Thu, 25 Oct 2018 18:47:34 +0200

segyio (1.7.1-1) unstable; urgency=medium

  * New upstream release
  * Uploader-email update to new Equinor address

 -- Jørgen Kvalsvik <jokva@equinor.com>  Mon, 15 Oct 2018 21:26:11 +0200

segyio (1.7.0-1) unstable; urgency=medium

  * New upstream release
  * Upgrade to Standards-Version 4.2.1
  * Add boost licence information to d/copyright for external/catch2

 -- Jørgen Kvalsvik <jokva@statoil.com>  Wed, 26 Sep 2018 15:23:14 +0200

=== debian/rules ===
#!/usr/bin/make -f

DEB_MAINT_BUILD_OPTIONS := hardening=+all
DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
DPKG_EXPORT_BUILDFLAGS = 1
LC_ALL := C.UTF-8
include /usr/share/dpkg/default.mk

export PYBUILD_NAME = segyio
export PYBUILD_BEFORE_TEST = cp -r {dir}/python/test {dir}/test-data {build_dir}
export SEGYIO_NO_GIT_VER=1
export LC_ALL

LIB_DIR = usr/lib/$(DEB_HOST_MULTIARCH)
STATIC = static-$(DEB_HOST_MULTIARCH)
DTMPLIB := $(CURDIR)/debian/tmp/$(LIB_DIR)

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure \
		-- -DBUILD_SHARED_LIBS=ON -DBUILD_PYTHON=OFF
	dh_auto_configure --builddirectory=$(STATIC) \
		-- -DBUILD_SHARED_LIBS=OFF -DBUILD_PYTHON=OFF -DBUILD_TESTING=OFF

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --builddirectory=$(STATIC)
	dh_auto_clean --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build
	dh_auto_build --builddirectory=$(STATIC)

override_dh_auto_install:
	dh_auto_install --builddirectory=$(STATIC)
	dh_auto_install
	dh_auto_build --buildsystem=pybuild -- \
		--build-args="build_ext --library-dirs $(DTMPLIB)"
	dh_auto_install --buildsystem=pybuild
	LD_LIBRARY_PATH=$(DTMPLIB):$(LD_LIBRARY_PATH) \
		dh_auto_test --buildsystem=pybuild -- --test-args=test/*

override_dh_python3:
	dh_python3 --requires=requirements.txt

override_dh_missing:
	dh_missing --list-missing

## segyio 1.8.1

=== debian/changelog ===
segyio (1.8.1-1) unstable; urgency=medium

  * New upstream release
  * Ignore python_files from setup.cfg (Closes: #916342)

 -- Jørgen Kvalsvik <jokva@equinor.com>  Wed, 19 Dec 2018 13:28:54 +0100

## segyio 1.8.2

=== debian/changelog ===
segyio (1.8.2-1) unstable; urgency=medium

  * New upstream release

 -- Jørgen Kvalsvik <jokva@equinor.com>  Thu, 20 Dec 2018 13:02:32 +0100

## segyio 1.8.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
 include(CheckIncludeFile)
 include(CTest)
 include(GNUInstallDirs)
+include(TestBigEndian)
 
 if (DEFINED ENV{SEGYIO_NO_GIT_VER})
     set(SEGYIO_NO_GIT_VER CACHE BOOL "Ignore version from git" ON)
@@ -58,29 +59,17 @@
 endif ()
 
 option(BUILD_SHARED_LIBS "Build language bindings shared"           OFF)
+option(BUILD_BIN         "Build applications"                       ON)
 option(BUILD_PYTHON      "Build Python library"                     ON)
 option(REQUIRE_PYTHON    "Fail cmake if python cannot be built"     OFF)
 option(BUILD_MEX         "Build Matlab mex files"                   OFF)
 option(BUILD_DOC         "Build documentation"                      OFF)
+option(EXPERIMENTAL      "Enable experimental features"             OFF)
 
-check_include_file(netinet/in.h     HAVE_NETINET_IN_H)
-check_include_file(arpa/inet.h      HAVE_ARPA_INET_H)
-check_include_file(winsock2.h       HAVE_WINSOCK2_H)
 check_include_file(getopt.h         HAVE_GETOPT_H)
 check_include_file(sys/mman.h       HAVE_SYS_MMAN_H)
 check_include_file(sys/stat.h       HAVE_SYS_STAT_H)
 check_function_exists(getopt_long   HAVE_GETOPT_LONG)
-
-if (HAVE_NETINET_IN_H)
-    list(APPEND htons -DHAVE_NETINET_IN_H)
-elseif (HAVE_ARPA_INET_H)
-    list(APPEND htons -DHAVE_ARPA_INET_H)
-elseif (HAVE_WINSOCK2_H)
-    set(ws2 ws2_32)
-    list(APPEND htons -DHAVE_WINSOCK2_H)
-else()
-    message(FATAL_ERROR "Could not find htons")
-endif()
 
 if (HAVE_SYS_MMAN_H)
     list(APPEND mmap -DHAVE_MMAP)
@@ -125,6 +114,8 @@
     list(APPEND warnings-c /W3 /wd4996)
 endif ()
 
+test_big_endian(HOST_BIG_ENDIAN)
+
 # add documentation master target for other documentation sub targets to hook
 # into
 add_custom_target(doc ALL)

=== requirements.txt ===
numpy >= 1.10

=== applications/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
 project(segyio-apps)
+
+if (NOT BUILD_BIN)
+    return ()
+endif ()
 
 if( NOT HAVE_GETOPT_H OR NOT HAVE_GETOPT_LONG )
     message(WARNING "Could not find getopt. Not building applications.")
@@ -49,6 +53,14 @@
 target_link_libraries(segyio-crop segyio apputils)
 target_compile_options(segyio-crop BEFORE
     PRIVATE $<$<CONFIG:Debug>:${warnings-c}> ${c99}
+)
+
+add_executable(flip-endianness flip-endianness.cpp)
+target_link_libraries(flip-endianness segyio)
+target_compile_options(flip-endianness BEFORE
+    PRIVATE
+        $<$<CONFIG:Debug>:${warnings-c}>
+        ${c++11}
 )
 
 install(TARGETS segyio-cath

=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-project(libsegyio C)
+project(libsegyio C CXX)
 
 if(MSVC)
     set(DLL_EXPORT_FILES src/segy.def)
@@ -13,10 +13,10 @@
 )
 target_compile_definitions(segyio
     PRIVATE
-        ${htons}
         ${mmap}
         ${fstat}
         ${ftello}
+        $<${HOST_BIG_ENDIAN}:HOST_BIG_ENDIAN>
 )
 set_target_properties(segyio
                       PROPERTIES
@@ -48,26 +48,48 @@
 )
 export(TARGETS segyio FILE segyio-config.cmake)
 
+if(EXPERIMENTAL)
+    install(DIRECTORY experimental/ DESTINATION include)
+endif()
+
 if (NOT BUILD_TESTING)
     return ()
 endif ()
 
-configure_file(${testdata}/small.sgy test-data/small.sgy             COPYONLY)
-configure_file(${testdata}/1x1.sgy   test-data/1x1.sgy               COPYONLY)
-configure_file(${testdata}/1xN.sgy   test-data/1xN.sgy               COPYONLY)
-configure_file(${testdata}/f3.sgy    test-data/f3.sgy                COPYONLY)
-configure_file(${testdata}/text.sgy  test-data/text.sgy              COPYONLY)
+configure_file(${testdata}/small.sgy                          test-data/small.sgy                            COPYONLY)
+configure_file(${testdata}/small-ps-dec-il-xl-off.sgy         test-data/small-ps-dec-il-xl-off.sgy           COPYONLY)
+configure_file(${testdata}/small-ps-dec-il-inc-xl-off.sgy     test-data/small-ps-dec-il-inc-xl-off.sgy       COPYONLY)
+configure_file(${testdata}/small-ps-dec-xl-inc-il-off.sgy     test-data/small-ps-dec-xl-inc-il-off.sgy       COPYONLY)
+configure_file(${testdata}/small-ps-dec-off-inc-il-xl.sgy     test-data/small-ps-dec-off-inc-il-xl.sgy       COPYONLY)
+configure_file(${testdata}/small-ps-dec-il-xl-inc-off.sgy     test-data/small-ps-dec-il-xl-inc-off.sgy       COPYONLY)
+configure_file(${testdata}/small-ps-dec-il-off-inc-xl.sgy     test-data/small-ps-dec-il-off-inc-xl.sgy       COPYONLY)
+configure_file(${testdata}/small-ps-dec-xl-off-inc-il.sgy     test-data/small-ps-dec-xl-off-inc-il.sgy       COPYONLY)
+configure_file(${testdata}/small.sgy                          test-data/small-w.sgy                          COPYONLY)
+configure_file(${testdata}/small-lsb.sgy                      test-data/small-lsb.sgy                        COPYONLY)
+configure_file(${testdata}/1x1.sgy                            test-data/1x1.sgy                              COPYONLY)
+configure_file(${testdata}/1xN.sgy                            test-data/1xN.sgy                              COPYONLY)
+configure_file(${testdata}/f3.sgy                             test-data/f3.sgy                               COPYONLY)
+configure_file(${testdata}/f3-lsb.sgy                         test-data/f3-lsb.sgy                           COPYONLY)
+configure_file(${testdata}/text.sgy                           test-data/text.sgy                             COPYONLY)
 
 add_executable(c.segy test/testsuite.cpp
                       test/segy.cpp
-                      test/mmap.cpp
+                      test/segyio-cpp.cpp
 )
-target_include_directories(c.segy PRIVATE src)
+target_include_directories(c.segy PRIVATE src experimental)
 target_link_libraries(c.segy catch2 segyio)
-target_compile_options(c.segy BEFORE PRIVATE
-    ${c++11}
-    ${mmap}
-    $<$<CONFIG:Debug>:${warnings-c}>
+target_compile_options(c.segy BEFORE
+    PRIVATE
+        ${c++11}
+        ${mmap}
+        $<$<CONFIG:Debug>:${warnings-c}>
 )
-add_test(NAME c.segy COMMAND c.segy ~[mmap] [c.segy])
-add_test(NAME c.segy.mmap COMMAND c.segy [mmap])
+target_compile_definitions(c.segy
+    PRIVATE
+        ${mmap}
+)
+add_test(NAME c.segy          COMMAND c.segy)
+add_test(NAME c.segy.mmap     COMMAND c.segy --test-mmap)
+add_test(NAME c.segy.lsb      COMMAND c.segy --test-lsb)
+add_test(NAME c.segy.mmap.lsb COMMAND c.segy --test-mmap --test-lsb)
+add_test(NAME cpp.segy        COMMAND c.segy [c++])

=== man/CMakeLists.txt ===
project(segyio-man)

if(NOT UNIX)
    return()
endif()

install(FILES segyio-cath.1
              segyio-catb.1
              segyio-catr.1
              segyio-crop.1          
        DESTINATION ${CMAKE_INSTALL_MANDIR}/man1
)

=== mex/CMakeLists.txt ===
project(segyio-mex)

if (NOT BUILD_MEX)
    unset(MATLAB_MCC CACHE)
    unset(MATLAB_MEX CACHE)
    unset(MATLAB_MEXEXT CACHE)
    unset(MATLAB_ROOT CACHE)
    unset(BUILD_MEX_TESTS CACHE)
    return()
endif()

include(matlab.cmake REQUIRED)

option(BUILD_MEX_TESTS "Build matlab mex tests" ON)

configure_file(Segy.m Segy.m)
configure_file(SegySpec.m SegySpec.m)
configure_file(SegySampleFormat.m SegySampleFormat.m)
configure_file(TraceSortingFormat.m TraceSortingFormat.m)
configure_file(TraceField.m TraceField.m)

get_property(dirs TARGET segyio-shared PROPERTY INCLUDE_DIRECTORIES)
include_directories(${dirs})

mexo(segyutil)
mex(segyspec_mex)
mex(segy_read_write_line_mex segyutil)
mex(segy_read_write_ps_line_mex segyutil)
mex(segy_get_header_mex segyutil)
mex(segy_get_traces_mex segyutil)
mex(segy_put_traces_mex segyutil)
mex(segy_get_ntraces_mex segyutil)
mex(segy_get_segy_header_mex segyutil)
mex(segy_get_bfield_mex segyutil)
mex(segy_get_trace_header_mex segyutil)
mex(segy_get_field_mex segyutil)
mex(segy_put_headers_mex segyutil)
mex(segy_get_offsets_mex segyutil)


install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/segyspec_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_read_write_line_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_read_write_ps_line_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_get_header_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_get_traces_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_put_traces_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_get_ntraces_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_get_segy_header_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_get_bfield_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_get_trace_header_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_get_field_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_put_headers_mex.mexa64
        ${CMAKE_CURRENT_BINARY_DIR}/segy_get_offsets_mex.mexa64
        SegySpec.m
        Segy.m
        SegySampleFormat.m
        TraceSortingFormat.m
        TraceField.m
        DESTINATION
        ${CMAKE_INSTALL_PREFIX}/matlab)

if(BUILD_MEX_TESTS)
    configure_file(${testdata}/small.sgy    test/test-data/small.sgy     COPYONLY)
    configure_file(${testdata}/small-ps.sgy test/test-data/small-ps.sgy  COPYONLY)
    add_matlab_test(matlab.spec test/segyspec.m)
    add_matlab_test(matlab.segy test/segy.m)
endif()

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -161,7 +161,7 @@
     return()
 endif()
 
-file(GLOB sgys "${testdata}/*.sgy")
+file(GLOB sgys ${testdata}/*.sgy ${testdata}/*.su)
 foreach (sgy ${sgys})
     get_filename_component(fl ${sgy} NAME)
     configure_file(${sgy} test-data/${fl} COPYONLY)

=== external/catch2/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(catch2 CXX)

# Dummy source file added because INTERFACE type
# library is not available in CMake 2.8.12
# it's STATIC, because MSVC would otherwise not generate a .lib file, making
# "linking" (for header path) fail later
#
# TODO: when cmake minimum version is bumped to 3.x series, replace with
# an INTERFACE library
add_library(catch2 STATIC dummy.cpp)
target_include_directories(catch2 SYSTEM PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== debian/changelog ===
segyio (1.8.3-1build2) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:25:43 +0100

segyio (1.8.3-1build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2019 18:44:05 +0000

segyio (1.8.3-1) unstable; urgency=medium

  * New upstream release

 -- Jørgen Kvalsvik <jokva@equinor.com>  Sun, 23 Dec 2018 13:17:03 +0100

=== debian/rules ===
--- 
+++ 
@@ -40,7 +40,7 @@
 		--build-args="build_ext --library-dirs $(DTMPLIB)"
 	dh_auto_install --buildsystem=pybuild
 	LD_LIBRARY_PATH=$(DTMPLIB):$(LD_LIBRARY_PATH) \
-		dh_auto_test --buildsystem=pybuild -- --test-args=test/*
+		dh_auto_test --buildsystem=pybuild -- --test-args="-o python_files=test/*"
 
 override_dh_python3:
 	dh_python3 --requires=requirements.txt

=== debian/watch ===
version=4
https://github.com/statoil/segyio/releases \
.*/segyio-@ANY_VERSION@@ARCHIVE_EXT@
